within ;
package mos 
  model ee "elektrick enelogie" 
    // demonstrace elektrickych analogii - jednoduchy poscilator
    
    Modelica.Electrical.Analog.Basic.Capacitor capacitor1(C = 1, v(start = 1, fixed = true)) annotation(Placement(visible = true, transformation(origin = {-28, -14}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Electrical.Analog.Basic.Inductor inductor1(L = 1) annotation(Placement(visible = true, transformation(origin = {10, -12}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Electrical.Analog.Basic.Ground ground1 annotation(Placement(visible = true, transformation(origin = {-54, -38}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  equation 
    connect(capacitor1.n, inductor1.p) annotation(Line(points = {{-18, -14}, {0, -14}, {0, -12}, {0, -12}}, color = {0, 0, 255}));
    connect(inductor1.n, capacitor1.p) annotation(Line(points = {{20, -12}, {38, -12}, {38, 34}, {-50, 34}, {-50, -14}, {-38, -14}, {-38, -14}}, color = {0, 0, 255}));
    connect(capacitor1.p, ground1.p) annotation(Line(points = {{-38, -14}, {-54, -14}, {-54, -28}, {-54, -28}}, color = {0, 0, 255}));
    annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})));
  end ee;
  
  ee ee1 annotation(Placement(visible = true, transformation(origin = {-24, -26}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  
  model eq 
    // koment
    /* delsi koment */
    
    // units jsou nepovinne, usnadnuji nam ale debugging rozsahlejsich modelu
    
    Real f(unit = "N") "sila";
    Real y(unit = "m") "pozice";
    Real v(start = 1, unit = "m/s");
    Real a(unit = "m.s-2");
    parameter Real m = 1;
    parameter Real k = 1;
  equation 
    
    // poradi rovnic ani leve a prave strany nejsou dulezite
    // je to vae matematika a ta prav - je to rovnost
    v = der(y);
    f = -k * y;
    -k * y = m * a;
    der(v) = a;
    
    // anotace jsou jenom pro graficke zobrazeni v diagram view a icon view
    annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})));
  end eq;
  
  connector con 
    Real y( unit = "m") "pozice v metrech";// non flow promenna - v kazdem spojeni konektoru je vzdy rovna
    flow Real f( unit="N") "sila v newtonech"; // flow promenna - v kazdem spojeni konektoru se scita do nuly - tj. jedno je kladne, druhe zaporne
    annotation(Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics = {Rectangle(origin=  {1, 0}, fillPattern=  FillPattern.Solid, extent=  {{-99, 100}, {99, -100}})}));
  end con;
  
  model pruzina 
  // anotace nemaji vliv na vypocet, jen na zobrazeni modelu
  // objekt con ma instanci con1
    con con1 annotation(Placement(visible = true, transformation(origin = {0, 78}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {0, 78}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    con con2 annotation(Placement(visible = true, transformation(origin = {2, -86}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {2, -86}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    parameter Real k;
  equation 
    con1.f = k * (con1.y - con2.y);
    con1.f + con2.f = 0;
    annotation(Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics = {Line(origin=  {14, -4.79835}, points=  {{-14, 66.7984}, {-42, 30.7984}, {46, 30.7984}, {-40, 6.79835}, {50, 0.798354}, {-50, -29.2016}, {14, -27.2016}, {-28, -49.2016}, {-12, -55.2016}, {-12, -67.2016}})}));
  end pruzina;
  
  model kulicka 
    parameter Real m = 1;
    parameter Real initPos;
    // lze napsat i 
      // Real y (start = 1);
    Real y;
    Real v;
    con con1 annotation(Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-84, 80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  initial equation 
    // budto v initial equation, nebo jako start hodnota (viz vyse)
    y = initPos;
  equation 
    con1.f = m * der(v);
    v = der(y);
    y = con1.y;
    annotation(Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics = {Ellipse(origin=  {-1, 2}, extent=  {{-87, 90}, {87, -90}}, endAngle=  360)}));
  end kulicka;
  
  model strop 
    con con1 annotation(Placement(visible = true, transformation(origin = {0, -84}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {0, -84}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  equation 
    con1.y = 0;
    annotation(Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics = {Rectangle(origin=  {1, -1}, extent=  {{-85, 83}, {85, -83}})}));
  end strop;
  
  model system 
    strop strop1 annotation(Placement(visible = true, transformation(origin = {-60, 78}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    kulicka kulicka1(initPos = 1) annotation(Placement(visible = true, transformation(origin = {6, -44}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    pruzina pruzina1(k = 1) annotation(Placement(visible = true, transformation(origin = {-4, -4}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    pruzina pruzina2(k = 2) annotation(Placement(visible = true, transformation(origin = {62, 48}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    kulicka kulicka2(m = 0.5, initPos = 0) annotation(Placement(visible = true, transformation(origin = {70, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  equation 
    connect(pruzina2.con1, kulicka1.con1) annotation(Line(points = {{62, 56}, {30, 56}, {30, -76}, {-20, -76}, {-20, -36}, {-2, -36}, {-2, -36}}));
    connect(pruzina2.con2, kulicka2.con1) annotation(Line(points = {{62, 39}, {62, 39}, {62, 6}, {62, 6}, {62, 6}}));
    connect(pruzina1.con2, kulicka1.con1) annotation(Line(points = {{-4, -13}, {-2, -13}, {-2, -36}, {-2, -36}}));
    connect(strop1.con1, pruzina1.con1) annotation(Line(points = {{-60, 70}, {-4, 70}, {-4, 4}}));
    annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})));
  end system;
  annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})), 
    uses(Modelica(version="2.2.2")));
end mos;
